import java.util.*;            // From "Principles of Parallel Programming", pages 190-192.
import java.util.concurrent.*;

public class Count3s implements Runnable
{
   private static final int ARRAY_LENGTH = 1048576; //  2^20
   private static final int MAX_THREADS = 16;       // be sure MAX_THREADS divides ARRAY_LENGTH
   private static final int MAX_RANGE = 100;
   private static final Random random = new Random();
   private static int count = 0;
   private static Object lock = new Object();
   private static int[] array = new int[ARRAY_LENGTH]; /*** initializ here ***/

   private int startIndex;
   private int elements;
   private int myCount = 0;

   public Count3s(int start, int elem)  // constructor
   {
      startIndex = start;
      elements = elem;
   }

   // Overload of run method in the Thread class (i.e., implement the Runnable interface)
   public void run()
   {
      // count the number of threes
      for(int i = 0; i < elements; i++)
      {
         if(array[startIndex+i] == 3)
         {
            myCount++;
         }
      }
      synchronized(lock)
      {
         count += myCount;
      }
   }//run()


   public static void main(String[] args)
   {
      // initialize the elements in the data array
      for(int i = 0; i < array.length; i++)
      {
         array[i] = random.nextInt(MAX_RANGE);
      }

      // create the threads
      Count3s[] counters = new Count3s[MAX_THREADS];
      int lengthPerThread = ARRAY_LENGTH / MAX_THREADS;// be sure MAX_THREADS divides ARRAY_LENGTH

      for(int i = 0; i < counters.length; i++)
      {
         counters[i] = new Count3s(i*lengthPerThread, lengthPerThread);
      }

      // run the threads
      Thread[] t = new Thread[counters.length];  /*** create the array of Thread references ***/
      for(int i = 0; i < counters.length; i++)
      {
         t[i] = new Thread(counters[i]); /* create a Thread object */
         t[i].start();                   /* run the thread */
      }
      for(int i = 0; i < counters.length; i++)
      {
         try
         {
            t[i].join(); /* wait for all the threads to complete */
         }
         catch(InterruptedException e)
         { /* do nothing */ }
      }

      // print the number of threes
      System.out.println("Number of threes: " + count);
   }//main()
}// class Count3s